/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/
// HTMLDrawer.h: interface for the CHTMLDrawer class.
//

#if !defined(AFX_HTMLDRAWER_H__DCF0B41F_7E7D_472A_BDDB_E8902BE074D6__INCLUDED_)
#define AFX_HTMLDRAWER_H__DCF0B41F_7E7D_472A_BDDB_E8902BE074D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CHTMLFont;
class CHTMLAtom;

class CHTMLDrawer  
{
public:
	CHTMLDrawer();
	virtual ~CHTMLDrawer();

	static void DrawText(CDC * pDC, const CString & strText,const CHTMLFont & fntDefault,CRect & rctPosition,short nAlignment,short nVAlignment, bool lineBreak, int newlineSpace, StringList &labelHREFClickRegions);
	static POINT MeasureText(CDC * pDC, const CString & strText,const CHTMLFont & fntDefault,CRect & rctPosition,short nAlignment,short nVAlignment, bool lineBreak, int newlineSpace);
	
protected:

	static  int FindDisplayAtoms(CDC * pDC, const CString & strText,const CHTMLFont & fntDefault,CRect & rctPosition,short nAlignment,short nVAlignment,bool lineBreak,int newlineSpace,CObArray & arrDisplayAtoms,CObArray & arrAnchors);
	static void ParseHTMLText(const CString & strSource,const CHTMLFont & Police,CObArray & arrAtoms,short nDefaultAlignment);
	static void FindTagAttributes(const CString & strAttributes,CStringArray & arrNames,CStringArray & arrValues);
	static bool AddText(CObArray & arrAtoms,const CString & strText,CHTMLFont & polCurrent,short nAlignment,const CString & strURL);
	static void UpdatePoliceAccordingToTag(CString & strTag,CHTMLFont & polCurrent,CObArray & arrFontStack,bool & isNewLine,short & nAlignment,short nDefaultAlignment,bool isLastAtomNewLine,CString & strURL);
	static void BreakIntoLines(CDC * pDC,CObArray & arrAtoms,CObArray & arrDisplayAtoms,CRect & rctPosition,CObArray & arrAnchors, bool lineBreak, int newlineSpace);
	static void CreateNewLine(CDC * pDC,CObArray & arrDisplayAtoms,int & nStartLineAtom,int & nY, int newlineSpace);
	static void RemoveLastWord(CString & strText);
	static void ApplyAlignments(CObArray & arrDisplayAtoms,int nShiftVertically,int nRight);
	static void DrawAtoms(CDC * pDC,CObArray & arrDisplayAtoms);
	static long FromHex(const CString & strHex);
	static void AlignLineAccordingToAscent(CObArray & arrDisplayAtoms,int nLowestAscent,int nStartLineAtom);
	static long ToLong(LPCTSTR lpszText);

	static void ConvertAnchorInStringList(CObArray & m_arrAnchors, StringList &labelHREFClickRegions);


};

#endif // !defined(AFX_HTMLDRAWER_H__DCF0B41F_7E7D_472A_BDDB_E8902BE074D6__INCLUDED_)
