/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_ICONTEXTURE_H__F00FC03F_E2C8_422B_A076_4B8994F42945__INCLUDED_)
#define AFX_ICONTEXTURE_H__F00FC03F_E2C8_422B_A076_4B8994F42945__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Texture.h"
#include "ExtractResource.h"

class IconTexture : public Texture
{

public:
	IconTexture();
	virtual ~IconTexture();

	void configure(const string &uniqueKey, const string &groupKey, bool alphaMap);
	void apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	void applyOverlay(HDC hDC, int x, int y, int width, int height, int alphaValue, int imageType);
	void applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return; };

	bool isTransparencyNeeded() { return transparencyNeeded; };

private:

	CIconExtractor m_IconExtractor;

	HICON GetIconFromLnkTarget(CString path, int iconSize, int imageMode);

	void CreateDCFromSource(HDC &destDC, HBITMAP &destBitmap, const string &uniqueKey, const string &groupKey, int imageType, HICON noalphaMapIcon);
	
	HDC memoryDC;
	HBITMAP memoryBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryPressedDC;
	HBITMAP memoryPressedBitmap;

	bool useAlphaMap;

	bool mustUseAlpha;
	bool hovermustUseAlpha;
	bool pressedmustUseAlpha;

	int iconSize;
	int hovericonSize;
	int pressediconSize;

	bool transparencyNeeded;

};

#endif // !defined(AFX_ICONTEXTURE_H__F00FC03F_E2C8_422B_A076_4B8994F42945__INCLUDED_)
