/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(__IMAGETEXTURE_H)
#define __IMAGETEXTURE_H

#include "Texture.h"

class ImageTexture : public Texture
{
public:

	ImageTexture();
	virtual ~ImageTexture();

	void configure(const string &uniqueKey, const string &groupKey, bool alphaMap);
	void apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	void applyOverlay(HDC hDC, int x, int y, int width, int height, int alphaValue, int imageType);
	void applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count);

	bool isTransparencyNeeded() { return transparencyNeeded; };

private:

	bool useAlphaMap;

	void PrepareAlphaChannel(HBITMAP &bmp, int imageType);

	void paintEffects(HDC &destHDC, int width, int height, int imageType);

	int leftEdge;
	int topEdge;
	int rightEdge;
	int bottomEdge;

	int mode;

	int hoverleftEdge;
	int hovertopEdge;
	int hoverrightEdge;
	int hoverbottomEdge;

	int hovermode;

	int pressedleftEdge;
	int pressedtopEdge;
	int pressedrightEdge;
	int pressedbottomEdge;

	int pressedmode;

	int saturation;
	int hueIntensity;
	COLORREF hueColor;

	int hoversaturation;
	int hoverhueIntensity;
	COLORREF hoverhueColor;

	int pressedsaturation;
	int pressedhueIntensity;
	COLORREF pressedhueColor;

	int frameWidth;
	int frameHeight;
	int hoverframeWidth;
	int hoverframeHeight;

	HDC memoryAnimDC;
	HBITMAP memoryAnimBitmap;

	HDC memoryHoverAnimDC;
	HBITMAP memoryHoverAnimBitmap;

	HDC memoryDC;
	HBITMAP memoryBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryPressedDC;
	HBITMAP memoryPressedBitmap;

	int imageHeight;
	int imageWidth;

	int hoverimageHeight;
	int hoverimageWidth;

	int pressedimageHeight;
	int pressedimageWidth;

	bool transparencyNeeded;
};

#endif
